%{

/* Copyright (c) 2000 by Tobin Fricke <tobin@splorg.org> */

#include "prettyc.h"
%}

%x		comment
%x		string

delim		[ \t\n]
ws		{delim}+
symbol		[\!\^\&\*\-\+\;\,\.\~\=\?\:]
bracket		[\{\(\[\]\)\}]
letter		[A-Za-z]
digit		[0-9]
number		{digit}+
cnumber		(0x)?{number}
charconst	\'\\?.\'
preprocessor	\#.*\n
identifier	{letter}*
keyword	auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto|if|int|long|register|return|short|signed|sizeof|static|struct|switch|typedef|union|void|volatile|while

%%
{keyword}	return TOK_KEYWORD;
{preprocessor}	return TOK_PREPROCESS;
{identifier}	return TOK_IDENTIFIER;
{cnumber}	return TOK_NUMBER;
{symbol}	return TOK_SYMBOL;
{bracket}	return TOK_BRACKET;
{ws}		return TOK_WHITESPACE;

\"                      BEGIN(string); yymore();
<string>[^"\\]*		yymore();
<string>\\.		yymore();
<string>[^"\\]*\"	BEGIN(INITIAL); return TOK_STRING;

\/\*			BEGIN(comment); yymore();
<comment>[^*]*		yymore();
<comment>\*+[^*/]	yymore();
<comment>\*+\/		BEGIN(INITIAL); return TOK_COMMENT;

%%
